The GNU Taler manual for Web shops
**********************************

This manual is for the GNU Taler merchant backend (version 0.5.0, 18
April 2019),

   Copyright (C) 2016, 2017, 2019 Taler Systems SA

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.3 or any later version published by the Free Software
     Foundation; with no Invariant Sections, with no Front-Cover Texts,
     and with no Back-Cover Texts.  A copy of the license is included in
     the section entitled "GNU Free Documentation License".

Appendices

Indices

Testing

1 Introduction
**************

1.1 About GNU Taler
===================

GNU Taler is an open protocol for an electronic payment system with a
free software reference implementation.  GNU Taler offers secure, fast
and easy payment processing using well understood cryptographic
techniques.  GNU Taler allows customers to remain anonymous, while
ensuring that merchants can be held accountable by governments.  Hence,
GNU Taler is compatible with anti-money-laundering (AML) and
know-your-customer (KYC) regulation, as well as data protection
regulation (such as GDPR).

   GNU Taler is not yet production-ready, after following this manual
you will have a backend that can process payments in "KUDOS", but not
regular currencies.  This is not so much because of limitations in the
backend, but because we are not aware of a Taler exchange operator
offering regular currencies today.

1.2 About this manual
=====================

This tutorial targets system administrators who want to install a GNU
Taler merchant _backend_.

   We expect some moderate familiarity with the compilation and
installation of free software packages.  An understanding of
cryptography is not required.

   This first chapter of the tutorial will give a brief overview of the
overall Taler architecture, describing the environment in which the
Taler backend operates.  The second chapter then explains how to install
the software, including key dependencies.  The third chapter will
explain how to configure the backend, including in particular the
configuration of the bank account details of the merchant.

   The last chapter gives some additional information about advanced
topics which will be useful for system administrators but are not
necessary for operating a basic backend.

1.3 Architecture overview
=========================

Taler is a pure payment system, not a new crypto-currency.  As such, it
operates in a traditional banking context.  In particular, this means
that in order to receive funds via Taler, the merchant must have a
regular bank account, and payments can be executed in ordinary
currencies such as USD or EUR. For testing purposes, Taler uses a
special currency "KUDOS" and includes its own special bank.

   The Taler software stack for a merchant consists of four main
components:

   * A frontend which interacts with the customer's browser.  The
     frontend enables the customer to build a shopping cart and place an
     order.  Upon payment, it triggers the respective business logic to
     satisfy the order.  This component is not included with Taler, but
     rather assumed to exist at the merchant.  This manual describes how
     to integrate Taler with Web shop frontends.
   * A back office application that enables the shop operators to view
     customer orders, match them to financial transfers, and possibly
     approve refunds if an order cannot be satisfied.  This component is
     again not included with Taler, but rather assumed to exist at the
     merchant.  This manual will describe how to integrate such a
     component to handle payments managed by Taler.
   * A Taler-specific payment backend which makes it easy for the
     frontend to process financial transactions with Taler.  The next
     two chapters will describe how to install and configure this
     backend.
   * A DBMS which stores the transaction history for the Taler backend.
     For now, the GNU Taler reference implemenation only supports
     Postgres, but the code could be easily extended to support another
     DBMS.

   The following image illustrates the various interactions of these key
components:

   Basically, the backend provides the cryptographic protocol support,
stores Taler-specific financial information in a DBMS and communicates
with the GNU Taler exchange over the Internet.  The frontend accesses
the backend via a RESTful API. As a result, the frontend never has to
directly communicate with the exchange, and also does not deal with
sensitive data.  In particular, the merchant's signing keys and bank
account information is encapsulated within the Taler backend.

2 Installation
**************

This chapter describes how to install the GNU Taler merchant backend.

2.1 Installing Taler using Docker
=================================

This section provides instructions for the merchant backend installation
using 'Docker'.

   For security reasons, we run Docker against a VirtualBox instance, so
the 'docker' command should connect to a 'docker-machine' instance that
uses the VirtualBox driver.

   Therefore, the needed tools are: "docker", "docker-machine", and
"docker-compose".  Please refer to Docker's official (1)documentation in
order to get those components installed, as that is not in this manual's
scope.

   Before starting to build the merchant's image, make sure a
"docker-machine" instance is up and running.

   Because all of the Docker source file are kept in our "deployment"
repository, we start by checking out the 'git://taler.net/deployment'
codebase:

     $ git clone git://taler.net/deployment

   Now we actually build the merchant's image.  From the same directory
as above:

     $ cd deployment/docker/merchant/
     $ docker-compose build

   If everything worked as expected, the merchant is ready to be
launched.  From the same directory as the previous step:

     # Recall: the docker-machine should be up and running.
     $ docker-compose up

   You should see some live logging from all the involved containers.
At this stage of development, you should also ignore some (harmless)
error message from postresql about already existing roles and databases.

   To test if everything worked as expected, it suffices to issue a
simple request to the merchant, as:

     $ curl http://$(docker-machine ip)/
     # A greeting message should be returned by the merchant.

   ---------- Footnotes ----------

   (1) https://docs.docker.com/

2.2 Generic instructions
========================

This section provides generic instructions for the merchant backend
installation independent of any particular operating system.  Operating
system specific instructions are provided in the following sections.
You should follow the operating system specific instructions if those
are available, and only consult the generic instructions if no
system-specific instructions are provided for your specific operating
system.

2.2.1 Installation of dependencies
----------------------------------

The following packages need to be installed before we can compile the
backend:

   * autoconf >= 2.69
   * automake >= 1.14
   * libtool >= 2.4
   * autopoint >= 0.19
   * libltdl >= 2.4
   * libunistring >= 0.9.3
   * libcurl >= 7.26 (or libgnurl >= 7.26)
   * GNU libmicrohttpd >= 0.9.39
   * GNU libgcrypt >= 1.6
   * libjansson >= 2.7
   * Postgres >= 9.4, including libpq
   * libgnunetutil (from Git)
   * GNU Taler exchange (from Git)

   Except for the last two, these are available in most GNU/Linux
distributions and should just be installed using the respective package
manager.

   The following sections will provide detailed instructions for
installing the libgnunetutil and GNU Taler exchange dependencies.

2.2.2 Installing libgnunetutil
------------------------------

Before you install libgnunetutil, you must download and install the
dependencies mentioned in the previous section, otherwise the build may
succeed but fail to export some of the tooling required by Taler.

   To download and install libgnunetutil, proceed as follows:

     $ git clone https://gnunet.org/git/gnunet/
     $ cd gnunet/
     $ ./bootstrap
     $ ./configure [--prefix=GNUNETPFX]
     $ # Each dependency can be fetched from non standard locations via
     $ # the '--with-<LIBNAME>' option. See './configure --help'.
     $ make
     # make install

   If you did not specify a prefix, GNUnet will install to '/usr/local',
which requires you to run the last step as 'root'.

2.2.3 Installing the GNU Taler exchange
---------------------------------------

After installing GNUnet, you can download and install the exchange as
follows:

     $ git clone git://taler.net/exchange
     $ cd exchange
     $ ./bootstrap
     $ ./configure [--prefix=EXCHANGEPFX] \
                   [--with-gnunet=GNUNETPFX]
     $ # Each dependency can be fetched from non standard locations via
     $ # the '--with-<LIBNAME>' option. See './configure --help'.
     $ make
     # make install

   If you did not specify a prefix, the exchange will install to
'/usr/local', which requires you to run the last step as 'root'.  Note
that you have to specify '--with-gnunet=/usr/local' if you installed
GNUnet to '/usr/local' in the previous step.

2.2.4 Installing the GNU Taler merchant backend
-----------------------------------------------

The following steps assume all dependencies are installed.

   Use the following commands to download and install the merchant
backend:

     $ git clone git://taler.net/merchant
     $ cd merchant
     $ ./bootstrap
     $ ./configure [--prefix=PFX] \
                   [--with-gnunet=GNUNETPFX] \
                   [--with-exchange=EXCHANGEPFX]
     $ # Each dependency can be fetched from non standard locations via
     $ # the '--with-<LIBNAME>' option. See './configure --help'.
     $ make
     $ make install

   Note that you have to specify '--with-exchange=/usr/local' and/or
'--with-exchange=/usr/local' if you installed the exchange and/or GNUnet
to '/usr/local' in the previous steps.

2.3 Installing Taler on Debian GNU/Linux
========================================

Debian wheezy is too old and lacks most of the packages required.

   On Debian jessie, only GNU libmicrohttpd needs to be compiled from
source.  To install dependencies on Debian jesse, run the following
commands:

     # apt-get install \
       autoconf \
       automake \
       autopoint \
       libtool \
       libltdl-dev \
       libunistring-dev \
       libcurl4-gnutls-dev \
       libgcrypt20-dev \
       libjansson-dev \
       libpq-dev \
       postgresql-9.4
     # wget https://ftp.gnu.org/gnu/libmicrohttpd/libmicrohttpd-latest.tar.gz
     # wget https://ftp.gnu.org/gnu/libmicrohttpd/libmicrohttpd-latest.tar.gz.sig
     # gpg -v libmicrohttpd-latest.tar.gz # Should show signed by 939E6BE1E29FC3CC
     # tar xf libmicrohttpd-latest.tar.gz
     # cd libmicrohttpd-0*
     # ./configure
     # make install

   For more recent versions of Debian, you should instead run:

     # apt-get install \
       autoconf \
       automake \
       autopoint \
       libtool \
       libltdl-dev \
       libunistring-dev \
       libcurl4-gnutls-dev \
       libgcrypt20-dev \
       libjansson-dev \
       libpq-dev \
       postgresql-9.5 \
       libmicrohttpd-dev

   For the rest of the installation, follow the generic installation
instructions starting with the installation of libgnunetutil.  Note that
if you used the Debian wheezy instructions above, you need to pass
'--with-microhttpd=/usr/local/' to all 'configure' invocations.

3 How to configure the merchant's backend
*****************************************

The installation already provides reasonable defaults for most of the
configuration options.  However, some must be provided, in particular
the database account and bank account that the backend should use.  By
default, the file '$HOME/.config/taler.conf' is where the Web shop
administrator specifies configuration values that augment or override
the defaults.  The format of the configuration file is the well-known
INI file format.  You can edit the file by hand, or use the
'taler-config' commands given as examples.  For more information on
'taler-config', see Using taler-config.

3.1 Backend options
===================

The following table describes the options that commonly need to be
modified.  Here, the notation '[$section]/$option' denotes the option
'$option' under the section '[$section]' in the configuration file.

Service address
     The following option sets the transport layer address used by the
     merchant backend:

          [MERCHANT]/SERVE = TCP | UNIX

     If given,
        * 'TCP', then we need to set the TCP port in '[MERCHANT]/PORT'
        * 'UNIX', then we need to set the unix domain socket path and
          mode in '[MERCHANT]/UNIXPATH' and '[MERCHANT]/UNIXPATH_MODE'.
          The latter takes the usual permission mask given as a number,
          e.g.  660 for user/group read-write access.

     The frontend can then connect to the backend over HTTP using the
     specified address.  If frontend and backend run within the same
     operating system, the use of a UNIX domain socket is recommended to
     avoid accidentally exposing the backend to the network.

     To run the Taler backend on TCP port 8888, use:
          $ taler-config -s MERCHANT -o SERVE -V TCP
          $ taler-config -s MERCHANT -o PORT -V 8888

Currency
     Which currency the Web shop deals in, i.e.  "EUR" or "USD", is
     specified using the option

          [TALER]/CURRENCY

     For testing purposes, the currency MUST match "KUDOS" so that tests
     will work with the Taler demonstration exchange at
     <https://exchange.demo.taler.net/>:

          $ taler-config -s TALER -o CURRENCY -V KUDOS

Database
     In principle is possible for the backend to support different
     DBMSs.  The option

          [MERCHANT]/DB

     specifies which DBMS is to be used.  However, currently only the
     value "postgres" is supported.  This is also the default.

     In addition to selecting the DBMS software, the backend requires
     DBMS-specific options to access the database.

     For postgres, you need to provide:

          [merchantdb-postgres]/config

     This option specifies a postgres access path using the format
     'postgres:///$DBNAME', where '$DBNAME' is the name of the Postgres
     database you want to use.  Suppose '$USER' is the name of the user
     who will run the backend process.  Then, you need to first run

          $ sudu -u postgres createuser -d $USER

     as the Postgres database administrator (usually 'postgres') to
     grant '$USER' the ability to create new databases.  Next, you
     should as '$USER' run:

          $ createdb $DBNAME

     to create the backend's database.  Here, '$DBNAME' must match the
     database name given in the configuration file.

     To configure the Taler backend to use this database, run:
          $ taler-config -s MERCHANTDB-postgres -o CONFIG \
            -V postgres:///$DBNAME

Exchange
     To add an exchange to the list of trusted payment service
     providers, you create a section with a name that starts with
     "exchange-".  In that section, the following options need to be
     configured:

        * The "url" option specifies the exchange's base URL. For
          example, to use the Taler demonstrator use:

               $ taler-config -s EXCHANGE-demo -o URL \
                 -V https://exchange.demo.taler.net/

        * The "master_key" option specifies the exchange's master public
          key in base32 encoding.  For the Taler demonstrator, use:

               $ taler-config -s EXCHANGE-demo -o master_key \
                 -V CQQZ9DY3MZ1ARMN5K1VKDETS04Y2QCKMMCFHZSWJWWVN82BTTH00

          Note that multiple exchanges can be added to the system by
          using different tokens in place of 'demo' in the example
          above.  Note that all of the exchanges must use the same
          currency.  If you need to support multiple currencies, you
          need to configure a backend per currency.

Instances
     The backend allows the user to run multiple instances of shops with
     distinct business entities against a single backend.  Each instance
     uses its own bank accounts and key for signing contracts.  It is
     mandatory to configure a "default" instance.

        * The "KEYFILE" option specifies the file containing the
          instance's private signing key.  For example, use:

               $ taler-config -s INSTANCE-default -o KEYFILE \
                 -V '${TALER_CONFIG_HOME}/merchant/instace/default.key'

        * The "NAME" option specifies a human-readable name for the
          instance.  For example, use:

               $ taler-config -s INSTANCE-default -o NAME \
                 -V 'Kudos Inc.'

        * The optional "TIP_EXCHANGE" and "TIP_EXCHANGE_PRIV_FILENAME"
          options are discussed in 'Tipping visitors'

Accounts
     In order to receive payments, the merchant backend needs to
     communicate bank account details to the exchange.  For this, the
     configuration must include one or more sections named
     "ACCOUNT-name" where 'name' can be replaced by some human-readable
     word identifying the account.  For each section, the following
     options should be provided:

        * The "URL" option specifies a 'payto://'-URL for the account of
          the merchant.  For example, use:

               $ taler-config -s ACCOUNT-bank -o NAME \
                 -V 'payto://x-taler-bank/bank.demo.taler.net/4'

        * The "WIRE_RESPONSE" option specifies where Taler should store
          the (salted) JSON encoding of the wire account.  The file
          given will be created if it does not exist.  For example, use:

               $ taler-config -s ACCOUNT-bank -o WIRE_RESPONSE \
                 -V '{$TALER_CONFIG_HOME}/merchant/bank.json'

        * The "PLUGIN" option specifies which wire plugin should be used
          for this account.  The plugin must support the wire method
          used by the URL. For example, use:

               $ taler-config -s ACCOUNT-bank -o PLUGIN \
                 -V taler_bank

        * For each 'instance' that should use this account, you should
          set 'HONOR_instance' and 'ACTIVE_instance' to YES. The first
          option will cause the instance to accept payments to the
          account (for existing contracts), while the second will cause
          the backend to include the account as a possible option for
          new contracts.

          For example, use:

               $ taler-config -s ACCOUNT-bank -o HONOR_default \
                 -V YES
               $ taler-config -s ACCOUNT-bank -o ACTIVE_default \
                 -V YES

          to use "account-bank" for the "default" instance.

     Depending on which PLUGIN you configured, you may additionally
     specfiy authentication options to enable the plugin to use the
     account.

     For example, with 'taler_bank' plugin, use:

          $ taler-config -s ACCOUNT-bank -o TALER_BANK_AUTH_METHOD \
            -V basic
          $ taler-config -s ACCOUNT-bank -o USERNAME \
            -V user42
          $ taler-config -s ACCOUNT-bank -o PASSWORD \
            -V pass42

     Note that additional instances can be specified using different
     tokens in the section name instead of 'default'.

3.2 Sample backend configuration
================================

The following is an example for a complete backend configuration:

     [TALER]
     CURRENCY = KUDOS

     [MERCHANT]
     SERVE = TCP
     PORT = 8888
     DATABASE = postgres

     [MERCHANTDB-postgres]
     CONFIG = postgres:///donations

     [INSTANCE-default]
     KEYFILE = $DATADIR/key.priv
     NAME = "Kudos Inc."

     [ACCOUNT-bank]
     URL = payto://x-taler-bank/bank.demo.taler.net/4
     WIRE_RESPONSE = $DATADIR/bank.json
     PLUGIN = taler_bank
     HONOR_default = YES
     ACTIVE_default = YES
     TALER_BANK_AUTH_METHOD = basic
     USERNAME = my_user
     PASSWORD = 1234pass

     [EXCHANGE-trusted]
     URL = https://exchange.demo.taler.net/
     MASTER_KEY = CQQZ9DY3MZ1ARMN5K1VKDETS04Y2QCKMMCFHZSWJWWVN82BTTH00
     CURRENCY = KUDOS

   Given the above configuration, the backend will use a database named
'donations' within Postgres.

   The backend will deposit the coins it receives to the exchange at
<https://exchange.demo.taler.net/>, which has the master key
"CQQZ9DY3MZ1ARMN5K1VKDETS04Y2QCKMMCFHZSWJWWVN82BTTH00".

   Please note that 'doc/config.sh' will walk you through all
configuration steps, showing how to invoke 'taler-config' for each of
them.

3.3 Launching the backend
=========================

Assuming you have configured everything correctly, you can launch the
merchant backend using:

     $ taler-merchant-httpd

   When launched for the first time, this command will print a message
about generating your private key.  If everything worked as expected,
the command

     $ curl http://localhost:8888/

   should return the message

     Hello, I'm a merchant's Taler backend. This HTTP server is not for humans.

   Please note that your backend is right now likely globally reachable.
Production systems should be configured to bind to a UNIX domain socket
or properly restrict access to the port.

4 Testing
*********

The tool 'taler-merchant-generate-payments' can be used to test the
merchant backend installation.  It implements all the payment's steps in
a programmatically way, relying on the backend you give it as input.
Note that this tool gets installed along all the merchant backend's
binaries.

   This tool gets configured by a config file, that must have the
following layout:

     [PAYMENTS-GENERATOR]

     # The exchange used during the test: make sure the merchant backend
     # being tested accpets this exchange.
     # If the sysadmin wants, she can also install a local exchange
     # and test against it.
     EXCHANGE = https://exchange.demo.taler.net/

     # This value must indicate some URL where the backend
     # to be tested is listening; it doesn't have to be the
     # "official" one, though.
     MERCHANT = http://localbackend/

     # This value is used when the tool tries to withdraw coins,
     # and must match the bank used by the exchange. If the test is
     # done against the exchange at https://exchange.demo.taler.net/,
     # then this value can be "https://bank.demo.taler.net/".
     BANK = https://bank.demo.taler.net/

     # The merchant instance in charge of serving the payment.
     # Make sure this instance has a bank account at the same bank
     # indicated by the 'bank' option above.
     INSTANCE = default

     # The currency used during the test. Must match the one used
     # by merchant backend and exchange.
     CURRENCY = KUDOS

   Run the test in the following way:

     $ taler-merchant-generate-payments [-c config] [-e EURL] [-m MURL]

   The argument 'config' given to '-c' points to the configuration file
and is optional - '~/.config/taler.conf' will be checked by default.  By
default, the tool forks two processes: one for the merchant backend, and
one for the exchange.  The option '-e' ('-m') avoids any exchange
(merchant backend) fork, and just runs the generator against the
exchange (merchant backend) running at 'EURL' ('MURL').

   Please NOTE that the generator contains _hardcoded_ values, as for
deposit fees of the coins it uses.  In order to work against the used
exchange, those values MUST match the ones used by the exchange.

   The following example shows how the generator "sets" a deposit fee of
EUR:0.01 for the 5 EURO coin.

     // from <merchant_repository>/src/sample/generate_payments.c
     { .oc = OC_PAY,
       .label = "deposit-simple",
       .expected_response_code = MHD_HTTP_OK,
       .details.pay.contract_ref = "create-proposal-1",
       .details.pay.coin_ref = "withdraw-coin-1",
       .details.pay.amount_with_fee = concat_amount (currency, "5"),
       .details.pay.amount_without_fee = concat_amount (currency, "4.99") },

   The logic calculates the deposit fee according to the subtraction:
'amount_with_fee - amount_without_fee'.

   The following example shows a 5 EURO coin configuration - needed by
the used exchange - which is compatible with the hardcoded example
above.

     [COIN_eur_5]
     value = EUR:5
     duration_overlap = 5 minutes
     duration_withdraw = 7 days
     duration_spend = 2 years
     duration_legal = 3 years
     fee_withdraw = EUR:0.00
     fee_deposit = EUR:0.01 # important bit
     fee_refresh = EUR:0.00
     fee_refund = EUR:0.00
     rsa_keysize = 1024

   If the command terminates with no errors, then the merchant backend
is correctly installed.

   After this operation is done, the merchant database will have some
dummy data in it, so it may be convenient to clean all the tables; to
this purpose, issue the following command:

     $ taler-merchant-dbinit -r

5 Advanced topics
*****************

5.1 Configuration format
========================

In Taler realm, any component obeys to the same pattern to get
configuration values.  According to this pattern, once the component has
been installed, the installation deploys default values in
'${prefix}/share/taler/config.d/', in '.conf' files.  In order to
override these defaults, the user can write a custom '.conf' file and
either pass it to the component at execution time, or name it
'taler.conf' and place it under '$HOME/.config/'.

   A config file is a text file containing 'sections', and each section
contains its 'values'.  The right format follows:

     [section1]
     value1 = string
     value2 = 23

     [section2]
     value21 = string
     value22 = /path22

   Throughout any configuration file, it is possible to use '$'-prefixed
variables, like '$VAR', especially when they represent filesystem paths.
It is also possible to provide defaults values for those variables that
are unset, by using the following syntax: '${VAR:-default}'.  However,
there are two ways a user can set '$'-prefixable variables:

   by defining them under a '[paths]' section, see example below,

     [paths]
     TALER_DEPLOYMENT_SHARED = ${HOME}/shared-data
     ..
     [section-x]
     path-x = ${TALER_DEPLOYMENT_SHARED}/x

   or by setting them in the environment:

     $ export VAR=/x

   The configuration loader will give precedence to variables set under
'[path]', though.

   The utility 'taler-config', which gets installed along with the
exchange, serves to get and set configuration values without directly
editing the '.conf'.  The option '-f' is particularly useful to resolve
pathnames, when they use several levels of '$'-expanded variables.  See
'taler-config --help'.

   Note that, in this stage of development, the file
'$HOME/.config/taler.conf' can contain sections for _all_ the component.
For example, both an exchange and a bank can read values from it.

   The repository 'git://taler.net/deployment' contains examples of
configuration file used in our demos.  See under 'deployment/config'.

     Note: Expectably, some components will not work just by using
     default values, as their work is often interdependent.  For
     example, a merchant needs to know an exchange URL, or a database
     name.

5.2 Using taler-config
======================

The tool 'taler-config' can be used to extract or manipulate
configuration values; however, the configuration use the well-known INI
file format and can also be edited by hand.

   Run
     $ taler-config -s $SECTION
   to list all of the configuration values in section '$SECTION'.

   Run
     $ taler-config -s $section -o $option
   to extract the respective configuration value for option '$option' in
section '$section'.

   Finally, to change a setting, run
     $ taler-config -s $section -o $option -V $value
   to set the respective configuration value to '$value'.  Note that you
have to manually restart the Taler backend after you change the
configuration to make the new configuration go into effect.

   Some default options will use $-variables, such as '$DATADIR' within
their value.  To expand the '$DATADIR' or other $-variables in the
configuration, pass the '-f' option to 'taler-config'.  For example,
compare:
     $ taler-config -s ACCOUNT-bank \
                    -o WIRE_RESPONSE
     $ taler-config -f -s ACCOUNT-bank \
                    -o WIRE_RESPONSE

   While the configuration file is typically located at
'$HOME/.config/taler.conf', an alternative location can be specified to
'taler-merchant-httpd' and 'taler-config' using the '-c' option.

5.3 Merchant key management
===========================

The option "KEYFILE" in the section "INSTANCE-default" specifies the
path to the instance's private key.  You do not need to create a key
manually, the backend will generate it automatically if it is missing.
While generally unnecessary, it is possible to display the corresponding
public key using the 'gnunet-ecc' command-line tool:

     $ gnunet-ecc -p                                  \
       $(taler-config -f -s INSTANCE-default \
                      -o KEYFILE)

5.4 Using the SEPA wire transfer method
=======================================

The following is a sample configuration for the SEPA wire transfer
method:(1).

   Then, to configure the EBICS backend for SEPA payments in EUR, the
following configuration options need to be set:

     $ taler-config -s TALER -o CURRENCY -V EUR
     $ taler-config -s ACCOUNT-e -o PLUGIN -V ebics
     $ taler-config -s ACCOUNT-e -o URL \
      -V payto://sepa/XY00111122223333444455556666
     $ taler-config -s ACCOUNT-e -o WIRE_RESPONSE
      -V '${DATADIR}/b.json'

   Please note that you will also have to configure an exchange and/or
auditors that support SEPA. However, we cannot explain how to do this
yet as such entities do not yet exist.  Once such entities do exist, we
expect future versions of the Taler backend to ship with pre-configured
exchanges and auditors for common denominations.

   ---------- Footnotes ----------

   (1) Supporting SEPA is still work in progress; the backend will
accept this configuration, but the exchange will not work with SEPA
today.

5.5 Tipping visitors
====================

Taler can also be used to tip Web site visitors.  For example, you may
be running an online survey, and you want to reward those people that
have dutifully completed the survey.  If they have installed a Taler
wallet, you can provide them with a tip for their deeds.  This section
describes how to setup the Taler merchant backend for tipping.

   There are four basic steps that must happen to tip a visitor.

5.5.1 Configure a reserve and exchange for tipping
--------------------------------------------------

To tip users, you first need to create a reserve.  A reserve is a pool
of money held in escrow at the Taler exchange.  This is the source of
the funds for the tips.  Tipping will fail (resulting in disappointed
visitors) if you do not have enough funds in your reserve!

   First, we configure the backend.  You need to enable tipping for each
instance separately, or you can use an instance only for tipping.  To
configure the "default" instance for tipping, use the following
configuration:

     [INSTANCE-default]
     # this is NOT the tip.priv
     KEYFILE = signing_key.priv
     # replace the URL with the URL of the exchange you will use
     TIP_EXCHANGE = https://exchange:443/
     # here put the path to the file created with "gnunet-ecc -g1 tip.priv"
     TIP_RESERVE_PRIV_FILENAME = tip.priv

   Note that the KEYFILE option should have already been present for the
instance.  It has nothing to do with the "tip.priv" file we created
above, and you should probably use a different file here.

   Instead of manually editing the configuration, you could also run:

     $ taler-config -s INSTANCE-default \
         -o TIP_RESERVE_PRIV_FILENAME \
         -V tip.priv
     $ taler-config -s INSTANCE-default \
         -o TIP_EXCHANGE \
         -V https://exchange:443/

   Next, to create the 'TIP_RESERVE_PRIV_FILENAME' file, use:

     $ gnunet-ecc -g 1   \
       $(taler-config -f -s INSTANCE-default \
           -o TIP-RESERVE_PRIV_FILENAME)

   This will create a file with the private key that will be used to
identify the reserve.  You need to do this once for each instance that
is configured to tip.

   Now you can (re)start the backend with the new configuration.

5.5.2 Fund the reserve
----------------------

To fund the reserve, you must first extract the public key from
"tip.priv":

     $ gnunet-ecc --print-public-key \
       $(taler-config -f -s INSTANCE-default \
           -o TIP-RESERVE_PRIV_FILENAME)

   In our example, the output for the public key is:

     QPE24X8PBX3BZ6E7GQ5VAVHV32FWTTCADR0TRQ183MSSJD2CHNEG

   You now need to make a wire transfer to the exchange's bank account
using the public key as the wire transfer subject.  The exchange's bank
account details can be found in JSON format at
"https://exchange:443//wire/METHOD" where METHOD is the respective wire
method (i.e.  "sepa").  Depending on the exchange's operator, you may
also be able to find the bank details in a human-readable format on the
main page of the exchange.

   Make your wire transfer and (optionally) check at
"https://exchange:443/reserve/status/reserve_pub=QPE24X..." whether your
transfer has arrived at the exchange.

   Once the funds have arrived, you can start to use the reserve for
tipping.

   Note that an exchange will typically close a reserve after four
weeks, wiring all remaining funds back to the sender's account.  Thus,
you should plan to wire funds corresponding to a campaign of about two
weeks to the exchange initially.  If your campaign runs longer, you
should wire further funds to the reserve every other week to prevent it
from expiring.

5.5.3 Authorize a tip
---------------------

When your frontend has reached the point where a client is supposed to
receive a tip, it needs to first authorize the tip.  For this, the
frontend must use the "/tip-authorize" API of the backend.  To authorize
a tip, the frontend has to provide the following information in the body
of the POST request:

   * The amount of the tip

   * The justification (only used internally for the back-office)

   * The URL where the wallet should navigate next after the tip was
     processed

   * The tip-pickup URL (see next section)

   In response to this request, the backend will return a tip token, an
expiration time and the exchange URL. The expiration time will indicate
how long the tip is valid (when the reserve expires).  The tip token is
an opaque string that contains all the information needed by the wallet
to process the tip.  The frontend must send this tip token to the
browser in a special "402 Payment Required" response inside the
'X-Taler-Tip' header.

   The frontend should handle errors returned by the backend, such as
missconfigured instances or a lack of remaining funds for tipping.

5.5.4 Picking up of the tip
---------------------------

The wallet will POST a JSON object to the shop's "/tip-pickup" handler.
The frontend must then forward this request to the backend.  The
response generated by the backend can then be forwarded directly to the
wallet.

5.6 Generate payments
=====================

The merchant codebase offers the 'taler-merchant-benchmark' tool to
populate the database with fake payments.  This tool is in charge of
starting a merchant, exchange, and bank processes, and provide them all
the input to accomplish payments.  Note that each component will use its
own configuration (as they would do in production).

   The tool takes all of the values it needs from the command line, with
some of them being mandatory.  Among those, we have:

   * '--currency=K' Use currency _K_, for example to craft coins to
     withdraw.
   * '--bank-url=URL' Assume that the bank is serving under the base URL
     _URL_. This option is only actually used by the tool to check if
     the bank was well launched.
   * '--merchant-url=URL' Reach the merchant through _URL_, for
     downloading contracts and sending payments.

   The tool then comes with two operation modes: _ordinary_, and
_corner_.  The first just executes normal payments, meaning that it uses
the default instance and make sure that all payments get aggregated.
The second gives the chance to leave some payments unaggregated, and
also to use merchant instances other than the default (which is,
actually, the one used by default by the tool).

   Note: the abilty of driving the aggregation policy is useful for
testing the backoffice facility.

   Any subcommand is also equipped with the canonical '--help' option,
so feel free to issue the following command in order to explore all the
possibilities.  For example:

     $ taler-merchant-benchmark corner --help

   will show all the options offered by the _corner_ mode.  Among the
most interesting, there are:

   * '--two-coins=TC' This option instructs the tool to perform _TC_
     many payments that use two coins, because normally only one coin is
     spent per payment.
   * '--unaggregated-number=UN' This option instructs the tool to
     perform _UN_ (one coin) payments that will be left unaggregated.
   * '--alt-instance=AI' This option instructs the tool to perform
     payments using the merchant instance _AI_ (instead of the _default_
     instance)

   As for the 'ordinary' subcommand, it is worth explaining the
following options:

   * '--payments-number=PN' Instructs the tool to perform _PN_ payments.
   * '--tracks-number=TN' Instructs the tool to perform _TN_ tracking
     operations.  Note that the total amount of operations will be two
     times _TN_, since "one" tracking operation accounts for
     '/track/transaction' and '/track/transfer'.  This command should
     only be used to see if the operation ends without problems, as no
     actual measurement of performance is provided (despite of the
     'benchmark' work used in the tool's name).

GNU-LGPL
********

                      Version 2.1, February 1999

     Copyright (C) 1991, 1999 Free Software Foundation, Inc.
     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

     [This is the first released version of the Lesser GPL.  It also counts
     as the successor of the GNU Library Public License, version 2, hence the
     version number 2.1.]

Preamble
--------

The licenses for most software are designed to take away your freedom to
share and change it.  By contrast, the GNU General Public Licenses are
intended to guarantee your freedom to share and change free software--to
make sure the software is free for all its users.

   This license, the Lesser General Public License, applies to some
specially designated software--typically libraries--of the Free Software
Foundation and other authors who decide to use it.  You can use it too,
but we suggest you first think carefully about whether this license or
the ordinary General Public License is the better strategy to use in any
particular case, based on the explanations below.

   When we speak of free software, we are referring to freedom of use,
not price.  Our General Public Licenses are designed to make sure that
you have the freedom to distribute copies of free software (and charge
for this service if you wish); that you receive source code or can get
it if you want it; that you can change the software and use pieces of it
in new free programs; and that you are informed that you can do these
things.

   To protect your rights, we need to make restrictions that forbid
distributors to deny you these rights or to ask you to surrender these
rights.  These restrictions translate to certain responsibilities for
you if you distribute copies of the library or if you modify it.

   For example, if you distribute copies of the library, whether gratis
or for a fee, you must give the recipients all the rights that we gave
you.  You must make sure that they, too, receive or can get the source
code.  If you link other code with the library, you must provide
complete object files to the recipients, so that they can relink them
with the library after making changes to the library and recompiling it.
And you must show them these terms so they know their rights.

   We protect your rights with a two-step method: (1) we copyright the
library, and (2) we offer you this license, which gives you legal
permission to copy, distribute and/or modify the library.

   To protect each distributor, we want to make it very clear that there
is no warranty for the free library.  Also, if the library is modified
by someone else and passed on, the recipients should know that what they
have is not the original version, so that the original author's
reputation will not be affected by problems that might be introduced by
others.

   Finally, software patents pose a constant threat to the existence of
any free program.  We wish to make sure that a company cannot
effectively restrict the users of a free program by obtaining a
restrictive license from a patent holder.  Therefore, we insist that any
patent license obtained for a version of the library must be consistent
with the full freedom of use specified in this license.

   Most GNU software, including some libraries, is covered by the
ordinary GNU General Public License.  This license, the GNU Lesser
General Public License, applies to certain designated libraries, and is
quite different from the ordinary General Public License.  We use this
license for certain libraries in order to permit linking those libraries
into non-free programs.

   When a program is linked with a library, whether statically or using
a shared library, the combination of the two is legally speaking a
combined work, a derivative of the original library.  The ordinary
General Public License therefore permits such linking only if the entire
combination fits its criteria of freedom.  The Lesser General Public
License permits more lax criteria for linking other code with the
library.

   We call this license the "Lesser" General Public License because it
does _Less_ to protect the user's freedom than the ordinary General
Public License.  It also provides other free software developers Less of
an advantage over competing non-free programs.  These disadvantages are
the reason we use the ordinary General Public License for many
libraries.  However, the Lesser license provides advantages in certain
special circumstances.

   For example, on rare occasions, there may be a special need to
encourage the widest possible use of a certain library, so that it
becomes a de-facto standard.  To achieve this, non-free programs must be
allowed to use the library.  A more frequent case is that a free library
does the same job as widely used non-free libraries.  In this case,
there is little to gain by limiting the free library to free software
only, so we use the Lesser General Public License.

   In other cases, permission to use a particular library in non-free
programs enables a greater number of people to use a large body of free
software.  For example, permission to use the GNU C Library in non-free
programs enables many more people to use the whole GNU operating system,
as well as its variant, the GNU/Linux operating system.

   Although the Lesser General Public License is Less protective of the
users' freedom, it does ensure that the user of a program that is linked
with the Library has the freedom and the wherewithal to run that program
using a modified version of the Library.

   The precise terms and conditions for copying, distribution and
modification follow.  Pay close attention to the difference between a
"work based on the library" and a "work that uses the library".  The
former contains code derived from the library, whereas the latter must
be combined with the library in order to run.

TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
---------------------------------------------------------------

  0. This License Agreement applies to any software library or other
     program which contains a notice placed by the copyright holder or
     other authorized party saying it may be distributed under the terms
     of this Lesser General Public License (also called "this License").
     Each licensee is addressed as "you".

     A "library" means a collection of software functions and/or data
     prepared so as to be conveniently linked with application programs
     (which use some of those functions and data) to form executables.

     The "Library", below, refers to any such software library or work
     which has been distributed under these terms.  A "work based on the
     Library" means either the Library or any derivative work under
     copyright law: that is to say, a work containing the Library or a
     portion of it, either verbatim or with modifications and/or
     translated straightforwardly into another language.  (Hereinafter,
     translation is included without limitation in the term
     "modification".)

     "Source code" for a work means the preferred form of the work for
     making modifications to it.  For a library, complete source code
     means all the source code for all modules it contains, plus any
     associated interface definition files, plus the scripts used to
     control compilation and installation of the library.

     Activities other than copying, distribution and modification are
     not covered by this License; they are outside its scope.  The act
     of running a program using the Library is not restricted, and
     output from such a program is covered only if its contents
     constitute a work based on the Library (independent of the use of
     the Library in a tool for writing it).  Whether that is true
     depends on what the Library does and what the program that uses the
     Library does.

  1. You may copy and distribute verbatim copies of the Library's
     complete source code as you receive it, in any medium, provided
     that you conspicuously and appropriately publish on each copy an
     appropriate copyright notice and disclaimer of warranty; keep
     intact all the notices that refer to this License and to the
     absence of any warranty; and distribute a copy of this License
     along with the Library.

     You may charge a fee for the physical act of transferring a copy,
     and you may at your option offer warranty protection in exchange
     for a fee.

  2. You may modify your copy or copies of the Library or any portion of
     it, thus forming a work based on the Library, and copy and
     distribute such modifications or work under the terms of Section 1
     above, provided that you also meet all of these conditions:

       a. The modified work must itself be a software library.

       b. You must cause the files modified to carry prominent notices
          stating that you changed the files and the date of any change.

       c. You must cause the whole of the work to be licensed at no
          charge to all third parties under the terms of this License.

       d. If a facility in the modified Library refers to a function or
          a table of data to be supplied by an application program that
          uses the facility, other than as an argument passed when the
          facility is invoked, then you must make a good faith effort to
          ensure that, in the event an application does not supply such
          function or table, the facility still operates, and performs
          whatever part of its purpose remains meaningful.

          (For example, a function in a library to compute square roots
          has a purpose that is entirely well-defined independent of the
          application.  Therefore, Subsection 2d requires that any
          application-supplied function or table used by this function
          must be optional: if the application does not supply it, the
          square root function must still compute square roots.)

     These requirements apply to the modified work as a whole.  If
     identifiable sections of that work are not derived from the
     Library, and can be reasonably considered independent and separate
     works in themselves, then this License, and its terms, do not apply
     to those sections when you distribute them as separate works.  But
     when you distribute the same sections as part of a whole which is a
     work based on the Library, the distribution of the whole must be on
     the terms of this License, whose permissions for other licensees
     extend to the entire whole, and thus to each and every part
     regardless of who wrote it.

     Thus, it is not the intent of this section to claim rights or
     contest your rights to work written entirely by you; rather, the
     intent is to exercise the right to control the distribution of
     derivative or collective works based on the Library.

     In addition, mere aggregation of another work not based on the
     Library with the Library (or with a work based on the Library) on a
     volume of a storage or distribution medium does not bring the other
     work under the scope of this License.

  3. You may opt to apply the terms of the ordinary GNU General Public
     License instead of this License to a given copy of the Library.  To
     do this, you must alter all the notices that refer to this License,
     so that they refer to the ordinary GNU General Public License,
     version 2, instead of to this License.  (If a newer version than
     version 2 of the ordinary GNU General Public License has appeared,
     then you can specify that version instead if you wish.)  Do not
     make any other change in these notices.

     Once this change is made in a given copy, it is irreversible for
     that copy, so the ordinary GNU General Public License applies to
     all subsequent copies and derivative works made from that copy.

     This option is useful when you wish to copy part of the code of the
     Library into a program that is not a library.

  4. You may copy and distribute the Library (or a portion or derivative
     of it, under Section 2) in object code or executable form under the
     terms of Sections 1 and 2 above provided that you accompany it with
     the complete corresponding machine-readable source code, which must
     be distributed under the terms of Sections 1 and 2 above on a
     medium customarily used for software interchange.

     If distribution of object code is made by offering access to copy
     from a designated place, then offering equivalent access to copy
     the source code from the same place satisfies the requirement to
     distribute the source code, even though third parties are not
     compelled to copy the source along with the object code.

  5. A program that contains no derivative of any portion of the
     Library, but is designed to work with the Library by being compiled
     or linked with it, is called a "work that uses the Library".  Such
     a work, in isolation, is not a derivative work of the Library, and
     therefore falls outside the scope of this License.

     However, linking a "work that uses the Library" with the Library
     creates an executable that is a derivative of the Library (because
     it contains portions of the Library), rather than a "work that uses
     the library".  The executable is therefore covered by this License.
     Section 6 states terms for distribution of such executables.

     When a "work that uses the Library" uses material from a header
     file that is part of the Library, the object code for the work may
     be a derivative work of the Library even though the source code is
     not.  Whether this is true is especially significant if the work
     can be linked without the Library, or if the work is itself a
     library.  The threshold for this to be true is not precisely
     defined by law.

     If such an object file uses only numerical parameters, data
     structure layouts and accessors, and small macros and small inline
     functions (ten lines or less in length), then the use of the object
     file is unrestricted, regardless of whether it is legally a
     derivative work.  (Executables containing this object code plus
     portions of the Library will still fall under Section 6.)

     Otherwise, if the work is a derivative of the Library, you may
     distribute the object code for the work under the terms of Section
     6.  Any executables containing that work also fall under Section 6,
     whether or not they are linked directly with the Library itself.

  6. As an exception to the Sections above, you may also combine or link
     a "work that uses the Library" with the Library to produce a work
     containing portions of the Library, and distribute that work under
     terms of your choice, provided that the terms permit modification
     of the work for the customer's own use and reverse engineering for
     debugging such modifications.

     You must give prominent notice with each copy of the work that the
     Library is used in it and that the Library and its use are covered
     by this License.  You must supply a copy of this License.  If the
     work during execution displays copyright notices, you must include
     the copyright notice for the Library among them, as well as a
     reference directing the user to the copy of this License.  Also,
     you must do one of these things:

       a. Accompany the work with the complete corresponding
          machine-readable source code for the Library including
          whatever changes were used in the work (which must be
          distributed under Sections 1 and 2 above); and, if the work is
          an executable linked with the Library, with the complete
          machine-readable "work that uses the Library", as object code
          and/or source code, so that the user can modify the Library
          and then relink to produce a modified executable containing
          the modified Library.  (It is understood that the user who
          changes the contents of definitions files in the Library will
          not necessarily be able to recompile the application to use
          the modified definitions.)

       b. Use a suitable shared library mechanism for linking with the
          Library.  A suitable mechanism is one that (1) uses at run
          time a copy of the library already present on the user's
          computer system, rather than copying library functions into
          the executable, and (2) will operate properly with a modified
          version of the library, if the user installs one, as long as
          the modified version is interface-compatible with the version
          that the work was made with.

       c. Accompany the work with a written offer, valid for at least
          three years, to give the same user the materials specified in
          Subsection 6a, above, for a charge no more than the cost of
          performing this distribution.

       d. If distribution of the work is made by offering access to copy
          from a designated place, offer equivalent access to copy the
          above specified materials from the same place.

       e. Verify that the user has already received a copy of these
          materials or that you have already sent this user a copy.

     For an executable, the required form of the "work that uses the
     Library" must include any data and utility programs needed for
     reproducing the executable from it.  However, as a special
     exception, the materials to be distributed need not include
     anything that is normally distributed (in either source or binary
     form) with the major components (compiler, kernel, and so on) of
     the operating system on which the executable runs, unless that
     component itself accompanies the executable.

     It may happen that this requirement contradicts the license
     restrictions of other proprietary libraries that do not normally
     accompany the operating system.  Such a contradiction means you
     cannot use both them and the Library together in an executable that
     you distribute.

  7. You may place library facilities that are a work based on the
     Library side-by-side in a single library together with other
     library facilities not covered by this License, and distribute such
     a combined library, provided that the separate distribution of the
     work based on the Library and of the other library facilities is
     otherwise permitted, and provided that you do these two things:

       a. Accompany the combined library with a copy of the same work
          based on the Library, uncombined with any other library
          facilities.  This must be distributed under the terms of the
          Sections above.

       b. Give prominent notice with the combined library of the fact
          that part of it is a work based on the Library, and explaining
          where to find the accompanying uncombined form of the same
          work.

  8. You may not copy, modify, sublicense, link with, or distribute the
     Library except as expressly provided under this License.  Any
     attempt otherwise to copy, modify, sublicense, link with, or
     distribute the Library is void, and will automatically terminate
     your rights under this License.  However, parties who have received
     copies, or rights, from you under this License will not have their
     licenses terminated so long as such parties remain in full
     compliance.

  9. You are not required to accept this License, since you have not
     signed it.  However, nothing else grants you permission to modify
     or distribute the Library or its derivative works.  These actions
     are prohibited by law if you do not accept this License.
     Therefore, by modifying or distributing the Library (or any work
     based on the Library), you indicate your acceptance of this License
     to do so, and all its terms and conditions for copying,
     distributing or modifying the Library or works based on it.

  10. Each time you redistribute the Library (or any work based on the
     Library), the recipient automatically receives a license from the
     original licensor to copy, distribute, link with or modify the
     Library subject to these terms and conditions.  You may not impose
     any further restrictions on the recipients' exercise of the rights
     granted herein.  You are not responsible for enforcing compliance
     by third parties with this License.

  11. If, as a consequence of a court judgment or allegation of patent
     infringement or for any other reason (not limited to patent
     issues), conditions are imposed on you (whether by court order,
     agreement or otherwise) that contradict the conditions of this
     License, they do not excuse you from the conditions of this
     License.  If you cannot distribute so as to satisfy simultaneously
     your obligations under this License and any other pertinent
     obligations, then as a consequence you may not distribute the
     Library at all.  For example, if a patent license would not permit
     royalty-free redistribution of the Library by all those who receive
     copies directly or indirectly through you, then the only way you
     could satisfy both it and this License would be to refrain entirely
     from distribution of the Library.

     If any portion of this section is held invalid or unenforceable
     under any particular circumstance, the balance of the section is
     intended to apply, and the section as a whole is intended to apply
     in other circumstances.

     It is not the purpose of this section to induce you to infringe any
     patents or other property right claims or to contest validity of
     any such claims; this section has the sole purpose of protecting
     the integrity of the free software distribution system which is
     implemented by public license practices.  Many people have made
     generous contributions to the wide range of software distributed
     through that system in reliance on consistent application of that
     system; it is up to the author/donor to decide if he or she is
     willing to distribute software through any other system and a
     licensee cannot impose that choice.

     This section is intended to make thoroughly clear what is believed
     to be a consequence of the rest of this License.

  12. If the distribution and/or use of the Library is restricted in
     certain countries either by patents or by copyrighted interfaces,
     the original copyright holder who places the Library under this
     License may add an explicit geographical distribution limitation
     excluding those countries, so that distribution is permitted only
     in or among countries not thus excluded.  In such case, this
     License incorporates the limitation as if written in the body of
     this License.

  13. The Free Software Foundation may publish revised and/or new
     versions of the Lesser General Public License from time to time.
     Such new versions will be similar in spirit to the present version,
     but may differ in detail to address new problems or concerns.

     Each version is given a distinguishing version number.  If the
     Library specifies a version number of this License which applies to
     it and "any later version", you have the option of following the
     terms and conditions either of that version or of any later version
     published by the Free Software Foundation.  If the Library does not
     specify a license version number, you may choose any version ever
     published by the Free Software Foundation.

  14. If you wish to incorporate parts of the Library into other free
     programs whose distribution conditions are incompatible with these,
     write to the author to ask for permission.  For software which is
     copyrighted by the Free Software Foundation, write to the Free
     Software Foundation; we sometimes make exceptions for this.  Our
     decision will be guided by the two goals of preserving the free
     status of all derivatives of our free software and of promoting the
     sharing and reuse of software generally.

                              NO WARRANTY

  15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO
     WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE
     LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS
     AND/OR OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY
     OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT
     LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
     FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND
     PERFORMANCE OF THE LIBRARY IS WITH YOU. SHOULD THE LIBRARY PROVE
     DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR
     OR CORRECTION.

  16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     MODIFY AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE
     LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
     INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
     INABILITY TO USE THE LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF
     DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU
     OR THIRD PARTIES OR A FAILURE OF THE LIBRARY TO OPERATE WITH ANY
     OTHER SOFTWARE), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN
     ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

END OF TERMS AND CONDITIONS
---------------------------

How to Apply These Terms to Your New Libraries
----------------------------------------------

If you develop a new library, and you want it to be of the greatest
possible use to the public, we recommend making it free software that
everyone can redistribute and change.  You can do so by permitting
redistribution under these terms (or, alternatively, under the terms of
the ordinary General Public License).

   To apply these terms, attach the following notices to the library.
It is safest to attach them to the start of each source file to most
effectively convey the exclusion of warranty; and each file should have
at least the "copyright" line and a pointer to where the full notice is
found.

     ONE LINE TO GIVE THE LIBRARY'S NAME AND AN IDEA OF WHAT IT DOES.
     Copyright (C) YEAR  NAME OF AUTHOR

     This library is free software; you can redistribute it and/or modify it
     under the terms of the GNU Lesser General Public License as published by
     the Free Software Foundation; either version 2.1 of the License, or (at
     your option) any later version.

     This library is distributed in the hope that it will be useful, but
     WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     Lesser General Public License for more details.

     You should have received a copy of the GNU Lesser General Public
     License along with this library; if not, write to the Free Software
     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
     USA.

   Also add information on how to contact you by electronic and paper
mail.

   You should also get your employer (if you work as a programmer) or
your school, if any, to sign a "copyright disclaimer" for the library,
if necessary.  Here is a sample; alter the names:

     Yoyodyne, Inc., hereby disclaims all copyright interest in the library
     `Frob' (a library for tweaking knobs) written by James Random Hacker.

     SIGNATURE OF TY COON, 1 April 1990
     Ty Coon, President of Vice

   That's all there is to it!

GNU Affero GPL
**************

                      Version 3, 19 November 2007

     Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>

     Everyone is permitted to copy and distribute verbatim copies of this
     license document, but changing it is not allowed.

Preamble
========

The GNU Affero General Public License is a free, copyleft license for
software and other kinds of works, specifically designed to ensure
cooperation with the community in the case of network server software.

   The licenses for most software and other practical works are designed
to take away your freedom to share and change the works.  By contrast,
our General Public Licenses are intended to guarantee your freedom to
share and change all versions of a program-to make sure it remains free
software for all its users.

   When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
them if you wish), that you receive source code or can get it if you
want it, that you can change the software or use pieces of it in new
free programs, and that you know you can do these things.

   Developers that use our General Public Licenses protect your rights
with two steps: (1) assert copyright on the software, and (2) offer you
this License which gives you legal permission to copy, distribute and/or
modify the software.

   A secondary benefit of defending all users' freedom is that
improvements made in alternate versions of the program, if they receive
widespread use, become available for other developers to incorporate.
Many developers of free software are heartened and encouraged by the
resulting cooperation.  However, in the case of software used on network
servers, this result may fail to come about.  The GNU General Public
License permits making a modified version and letting the public access
it on a server without ever releasing its source code to the public.

   The GNU Affero General Public License is designed specifically to
ensure that, in such cases, the modified source code becomes available
to the community.  It requires the operator of a network server to
provide the source code of the modified version running there to the
users of that server.  Therefore, public use of a modified version, on a
publicly accessible server, gives the public access to the source code
of the modified version.

   An older license, called the Affero General Public License and
published by Affero, was designed to accomplish similar goals.  This is
a different license, not a version of the Affero GPL, but Affero has
released a new version of the Affero GPL which permits relicensing under
this license.

   The precise terms and conditions for copying, distribution and
modification follow.

TERMS AND CONDITIONS
====================

  0. Definitions.

     "This License" refers to version 3 of the GNU Affero General Public
     License.

     "Copyright" also means copyright-like laws that apply to other
     kinds of works, such as semiconductor masks.

     "The Program" refers to any copyrightable work licensed under this
     License.  Each licensee is addressed as "you".  "Licensees" and
     "recipients" may be individuals or organizations.

     To "modify" a work means to copy from or adapt all or part of the
     work in a fashion requiring copyright permission, other than the
     making of an exact copy.  The resulting work is called a "modified
     version" of the earlier work or a work "based on" the earlier work.

     A "covered work" means either the unmodified Program or a work
     based on the Program.

     To "propagate" a work means to do anything with it that, without
     permission, would make you directly or secondarily liable for
     infringement under applicable copyright law, except executing it on
     a computer or modifying a private copy.  Propagation includes
     copying, distribution (with or without modification), making
     available to the public, and in some countries other activities as
     well.

     To "convey" a work means any kind of propagation that enables other
     parties to make or receive copies.  Mere interaction with a user
     through a computer network, with no transfer of a copy, is not
     conveying.

     An interactive user interface displays "Appropriate Legal Notices"
     to the extent that it includes a convenient and prominently visible
     feature that (1) displays an appropriate copyright notice, and (2)
     tells the user that there is no warranty for the work (except to
     the extent that warranties are provided), that licensees may convey
     the work under this License, and how to view a copy of this
     License.  If the interface presents a list of user commands or
     options, such as a menu, a prominent item in the list meets this
     criterion.

  1. Source Code.

     The "source code" for a work means the preferred form of the work
     for making modifications to it.  "Object code" means any non-source
     form of a work.

     A "Standard Interface" means an interface that either is an
     official standard defined by a recognized standards body, or, in
     the case of interfaces specified for a particular programming
     language, one that is widely used among developers working in that
     language.

     The "System Libraries" of an executable work include anything,
     other than the work as a whole, that (a) is included in the normal
     form of packaging a Major Component, but which is not part of that
     Major Component, and (b) serves only to enable use of the work with
     that Major Component, or to implement a Standard Interface for
     which an implementation is available to the public in source code
     form.  A "Major Component", in this context, means a major
     essential component (kernel, window system, and so on) of the
     specific operating system (if any) on which the executable work
     runs, or a compiler used to produce the work, or an object code
     interpreter used to run it.

     The "Corresponding Source" for a work in object code form means all
     the source code needed to generate, install, and (for an executable
     work) run the object code and to modify the work, including scripts
     to control those activities.  However, it does not include the
     work's System Libraries, or general-purpose tools or generally
     available free programs which are used unmodified in performing
     those activities but which are not part of the work.  For example,
     Corresponding Source includes interface definition files associated
     with source files for the work, and the source code for shared
     libraries and dynamically linked subprograms that the work is
     specifically designed to require, such as by intimate data
     communication or control flow between those subprograms and other
     parts of the work.

     The Corresponding Source need not include anything that users can
     regenerate automatically from other parts of the Corresponding
     Source.

     The Corresponding Source for a work in source code form is that
     same work.

  2. Basic Permissions.

     All rights granted under this License are granted for the term of
     copyright on the Program, and are irrevocable provided the stated
     conditions are met.  This License explicitly affirms your unlimited
     permission to run the unmodified Program.  The output from running
     a covered work is covered by this License only if the output, given
     its content, constitutes a covered work.  This License acknowledges
     your rights of fair use or other equivalent, as provided by
     copyright law.

     You may make, run and propagate covered works that you do not
     convey, without conditions so long as your license otherwise
     remains in force.  You may convey covered works to others for the
     sole purpose of having them make modifications exclusively for you,
     or provide you with facilities for running those works, provided
     that you comply with the terms of this License in conveying all
     material for which you do not control copyright.  Those thus making
     or running the covered works for you must do so exclusively on your
     behalf, under your direction and control, on terms that prohibit
     them from making any copies of your copyrighted material outside
     their relationship with you.

     Conveying under any other circumstances is permitted solely under
     the conditions stated below.  Sublicensing is not allowed; section
     10 makes it unnecessary.

  3. Protecting Users' Legal Rights From Anti-Circumvention Law.

     No covered work shall be deemed part of an effective technological
     measure under any applicable law fulfilling obligations under
     article 11 of the WIPO copyright treaty adopted on 20 December
     1996, or similar laws prohibiting or restricting circumvention of
     such measures.

     When you convey a covered work, you waive any legal power to forbid
     circumvention of technological measures to the extent such
     circumvention is effected by exercising rights under this License
     with respect to the covered work, and you disclaim any intention to
     limit operation or modification of the work as a means of
     enforcing, against the work's users, your or third parties' legal
     rights to forbid circumvention of technological measures.

  4. Conveying Verbatim Copies.

     You may convey verbatim copies of the Program's source code as you
     receive it, in any medium, provided that you conspicuously and
     appropriately publish on each copy an appropriate copyright notice;
     keep intact all notices stating that this License and any
     non-permissive terms added in accord with section 7 apply to the
     code; keep intact all notices of the absence of any warranty; and
     give all recipients a copy of this License along with the Program.

     You may charge any price or no price for each copy that you convey,
     and you may offer support or warranty protection for a fee.

  5. Conveying Modified Source Versions.

     You may convey a work based on the Program, or the modifications to
     produce it from the Program, in the form of source code under the
     terms of section 4, provided that you also meet all of these
     conditions:

       a. The work must carry prominent notices stating that you
          modified it, and giving a relevant date.

       b. The work must carry prominent notices stating that it is
          released under this License and any conditions added under
          section 7.  This requirement modifies the requirement in
          section 4 to "keep intact all notices".

       c. You must license the entire work, as a whole, under this
          License to anyone who comes into possession of a copy.  This
          License will therefore apply, along with any applicable
          section 7 additional terms, to the whole of the work, and all
          its parts, regardless of how they are packaged.  This License
          gives no permission to license the work in any other way, but
          it does not invalidate such permission if you have separately
          received it.

       d. If the work has interactive user interfaces, each must display
          Appropriate Legal Notices; however, if the Program has
          interactive interfaces that do not display Appropriate Legal
          Notices, your work need not make them do so.

     A compilation of a covered work with other separate and independent
     works, which are not by their nature extensions of the covered
     work, and which are not combined with it such as to form a larger
     program, in or on a volume of a storage or distribution medium, is
     called an "aggregate" if the compilation and its resulting
     copyright are not used to limit the access or legal rights of the
     compilation's users beyond what the individual works permit.
     Inclusion of a covered work in an aggregate does not cause this
     License to apply to the other parts of the aggregate.

  6. Conveying Non-Source Forms.

     You may convey a covered work in object code form under the terms
     of sections 4 and 5, provided that you also convey the
     machine-readable Corresponding Source under the terms of this
     License, in one of these ways:

       a. Convey the object code in, or embodied in, a physical product
          (including a physical distribution medium), accompanied by the
          Corresponding Source fixed on a durable physical medium
          customarily used for software interchange.

       b. Convey the object code in, or embodied in, a physical product
          (including a physical distribution medium), accompanied by a
          written offer, valid for at least three years and valid for as
          long as you offer spare parts or customer support for that
          product model, to give anyone who possesses the object code
          either (1) a copy of the Corresponding Source for all the
          software in the product that is covered by this License, on a
          durable physical medium customarily used for software
          interchange, for a price no more than your reasonable cost of
          physically performing this conveying of source, or (2) access
          to copy the Corresponding Source from a network server at no
          charge.

       c. Convey individual copies of the object code with a copy of the
          written offer to provide the Corresponding Source.  This
          alternative is allowed only occasionally and noncommercially,
          and only if you received the object code with such an offer,
          in accord with subsection 6b.

       d. Convey the object code by offering access from a designated
          place (gratis or for a charge), and offer equivalent access to
          the Corresponding Source in the same way through the same
          place at no further charge.  You need not require recipients
          to copy the Corresponding Source along with the object code.
          If the place to copy the object code is a network server, the
          Corresponding Source may be on a different server (operated by
          you or a third party) that supports equivalent copying
          facilities, provided you maintain clear directions next to the
          object code saying where to find the Corresponding Source.
          Regardless of what server hosts the Corresponding Source, you
          remain obligated to ensure that it is available for as long as
          needed to satisfy these requirements.

       e. Convey the object code using peer-to-peer transmission,
          provided you inform other peers where the object code and
          Corresponding Source of the work are being offered to the
          general public at no charge under subsection 6d.

     A separable portion of the object code, whose source code is
     excluded from the Corresponding Source as a System Library, need
     not be included in conveying the object code work.

     A "User Product" is either (1) a "consumer product", which means
     any tangible personal property which is normally used for personal,
     family, or household purposes, or (2) anything designed or sold for
     incorporation into a dwelling.  In determining whether a product is
     a consumer product, doubtful cases shall be resolved in favor of
     coverage.  For a particular product received by a particular user,
     "normally used" refers to a typical or common use of that class of
     product, regardless of the status of the particular user or of the
     way in which the particular user actually uses, or expects or is
     expected to use, the product.  A product is a consumer product
     regardless of whether the product has substantial commercial,
     industrial or non-consumer uses, unless such uses represent the
     only significant mode of use of the product.

     "Installation Information" for a User Product means any methods,
     procedures, authorization keys, or other information required to
     install and execute modified versions of a covered work in that
     User Product from a modified version of its Corresponding Source.
     The information must suffice to ensure that the continued
     functioning of the modified object code is in no case prevented or
     interfered with solely because modification has been made.

     If you convey an object code work under this section in, or with,
     or specifically for use in, a User Product, and the conveying
     occurs as part of a transaction in which the right of possession
     and use of the User Product is transferred to the recipient in
     perpetuity or for a fixed term (regardless of how the transaction
     is characterized), the Corresponding Source conveyed under this
     section must be accompanied by the Installation Information.  But
     this requirement does not apply if neither you nor any third party
     retains the ability to install modified object code on the User
     Product (for example, the work has been installed in ROM).

     The requirement to provide Installation Information does not
     include a requirement to continue to provide support service,
     warranty, or updates for a work that has been modified or installed
     by the recipient, or for the User Product in which it has been
     modified or installed.  Access to a network may be denied when the
     modification itself materially and adversely affects the operation
     of the network or violates the rules and protocols for
     communication across the network.

     Corresponding Source conveyed, and Installation Information
     provided, in accord with this section must be in a format that is
     publicly documented (and with an implementation available to the
     public in source code form), and must require no special password
     or key for unpacking, reading or copying.

  7. Additional Terms.

     "Additional permissions" are terms that supplement the terms of
     this License by making exceptions from one or more of its
     conditions.  Additional permissions that are applicable to the
     entire Program shall be treated as though they were included in
     this License, to the extent that they are valid under applicable
     law.  If additional permissions apply only to part of the Program,
     that part may be used separately under those permissions, but the
     entire Program remains governed by this License without regard to
     the additional permissions.

     When you convey a copy of a covered work, you may at your option
     remove any additional permissions from that copy, or from any part
     of it.  (Additional permissions may be written to require their own
     removal in certain cases when you modify the work.)  You may place
     additional permissions on material, added by you to a covered work,
     for which you have or can give appropriate copyright permission.

     Notwithstanding any other provision of this License, for material
     you add to a covered work, you may (if authorized by the copyright
     holders of that material) supplement the terms of this License with
     terms:

       a. Disclaiming warranty or limiting liability differently from
          the terms of sections 15 and 16 of this License; or

       b. Requiring preservation of specified reasonable legal notices
          or author attributions in that material or in the Appropriate
          Legal Notices displayed by works containing it; or

       c. Prohibiting misrepresentation of the origin of that material,
          or requiring that modified versions of such material be marked
          in reasonable ways as different from the original version; or

       d. Limiting the use for publicity purposes of names of licensors
          or authors of the material; or

       e. Declining to grant rights under trademark law for use of some
          trade names, trademarks, or service marks; or

       f. Requiring indemnification of licensors and authors of that
          material by anyone who conveys the material (or modified
          versions of it) with contractual assumptions of liability to
          the recipient, for any liability that these contractual
          assumptions directly impose on those licensors and authors.

     All other non-permissive additional terms are considered "further
     restrictions" within the meaning of section 10.  If the Program as
     you received it, or any part of it, contains a notice stating that
     it is governed by this License along with a term that is a further
     restriction, you may remove that term.  If a license document
     contains a further restriction but permits relicensing or conveying
     under this License, you may add to a covered work material governed
     by the terms of that license document, provided that the further
     restriction does not survive such relicensing or conveying.

     If you add terms to a covered work in accord with this section, you
     must place, in the relevant source files, a statement of the
     additional terms that apply to those files, or a notice indicating
     where to find the applicable terms.

     Additional terms, permissive or non-permissive, may be stated in
     the form of a separately written license, or stated as exceptions;
     the above requirements apply either way.

  8. Termination.

     You may not propagate or modify a covered work except as expressly
     provided under this License.  Any attempt otherwise to propagate or
     modify it is void, and will automatically terminate your rights
     under this License (including any patent licenses granted under the
     third paragraph of section 11).

     However, if you cease all violation of this License, then your
     license from a particular copyright holder is reinstated (a)
     provisionally, unless and until the copyright holder explicitly and
     finally terminates your license, and (b) permanently, if the
     copyright holder fails to notify you of the violation by some
     reasonable means prior to 60 days after the cessation.

     Moreover, your license from a particular copyright holder is
     reinstated permanently if the copyright holder notifies you of the
     violation by some reasonable means, this is the first time you have
     received notice of violation of this License (for any work) from
     that copyright holder, and you cure the violation prior to 30 days
     after your receipt of the notice.

     Termination of your rights under this section does not terminate
     the licenses of parties who have received copies or rights from you
     under this License.  If your rights have been terminated and not
     permanently reinstated, you do not qualify to receive new licenses
     for the same material under section 10.

  9. Acceptance Not Required for Having Copies.

     You are not required to accept this License in order to receive or
     run a copy of the Program.  Ancillary propagation of a covered work
     occurring solely as a consequence of using peer-to-peer
     transmission to receive a copy likewise does not require
     acceptance.  However, nothing other than this License grants you
     permission to propagate or modify any covered work.  These actions
     infringe copyright if you do not accept this License.  Therefore,
     by modifying or propagating a covered work, you indicate your
     acceptance of this License to do so.

  10. Automatic Licensing of Downstream Recipients.

     Each time you convey a covered work, the recipient automatically
     receives a license from the original licensors, to run, modify and
     propagate that work, subject to this License.  You are not
     responsible for enforcing compliance by third parties with this
     License.

     An "entity transaction" is a transaction transferring control of an
     organization, or substantially all assets of one, or subdividing an
     organization, or merging organizations.  If propagation of a
     covered work results from an entity transaction, each party to that
     transaction who receives a copy of the work also receives whatever
     licenses to the work the party's predecessor in interest had or
     could give under the previous paragraph, plus a right to possession
     of the Corresponding Source of the work from the predecessor in
     interest, if the predecessor has it or can get it with reasonable
     efforts.

     You may not impose any further restrictions on the exercise of the
     rights granted or affirmed under this License.  For example, you
     may not impose a license fee, royalty, or other charge for exercise
     of rights granted under this License, and you may not initiate
     litigation (including a cross-claim or counterclaim in a lawsuit)
     alleging that any patent claim is infringed by making, using,
     selling, offering for sale, or importing the Program or any portion
     of it.

  11. Patents.

     A "contributor" is a copyright holder who authorizes use under this
     License of the Program or a work on which the Program is based.
     The work thus licensed is called the contributor's "contributor
     version".

     A contributor's "essential patent claims" are all patent claims
     owned or controlled by the contributor, whether already acquired or
     hereafter acquired, that would be infringed by some manner,
     permitted by this License, of making, using, or selling its
     contributor version, but do not include claims that would be
     infringed only as a consequence of further modification of the
     contributor version.  For purposes of this definition, "control"
     includes the right to grant patent sublicenses in a manner
     consistent with the requirements of this License.

     Each contributor grants you a non-exclusive, worldwide,
     royalty-free patent license under the contributor's essential
     patent claims, to make, use, sell, offer for sale, import and
     otherwise run, modify and propagate the contents of its contributor
     version.

     In the following three paragraphs, a "patent license" is any
     express agreement or commitment, however denominated, not to
     enforce a patent (such as an express permission to practice a
     patent or covenant not to sue for patent infringement).  To "grant"
     such a patent license to a party means to make such an agreement or
     commitment not to enforce a patent against the party.

     If you convey a covered work, knowingly relying on a patent
     license, and the Corresponding Source of the work is not available
     for anyone to copy, free of charge and under the terms of this
     License, through a publicly available network server or other
     readily accessible means, then you must either (1) cause the
     Corresponding Source to be so available, or (2) arrange to deprive
     yourself of the benefit of the patent license for this particular
     work, or (3) arrange, in a manner consistent with the requirements
     of this License, to extend the patent license to downstream
     recipients.  "Knowingly relying" means you have actual knowledge
     that, but for the patent license, your conveying the covered work
     in a country, or your recipient's use of the covered work in a
     country, would infringe one or more identifiable patents in that
     country that you have reason to believe are valid.

     If, pursuant to or in connection with a single transaction or
     arrangement, you convey, or propagate by procuring conveyance of, a
     covered work, and grant a patent license to some of the parties
     receiving the covered work authorizing them to use, propagate,
     modify or convey a specific copy of the covered work, then the
     patent license you grant is automatically extended to all
     recipients of the covered work and works based on it.

     A patent license is "discriminatory" if it does not include within
     the scope of its coverage, prohibits the exercise of, or is
     conditioned on the non-exercise of one or more of the rights that
     are specifically granted under this License.  You may not convey a
     covered work if you are a party to an arrangement with a third
     party that is in the business of distributing software, under which
     you make payment to the third party based on the extent of your
     activity of conveying the work, and under which the third party
     grants, to any of the parties who would receive the covered work
     from you, a discriminatory patent license (a) in connection with
     copies of the covered work conveyed by you (or copies made from
     those copies), or (b) primarily for and in connection with specific
     products or compilations that contain the covered work, unless you
     entered into that arrangement, or that patent license was granted,
     prior to 28 March 2007.

     Nothing in this License shall be construed as excluding or limiting
     any implied license or other defenses to infringement that may
     otherwise be available to you under applicable patent law.

  12. No Surrender of Others' Freedom.

     If conditions are imposed on you (whether by court order, agreement
     or otherwise) that contradict the conditions of this License, they
     do not excuse you from the conditions of this License.  If you
     cannot convey a covered work so as to satisfy simultaneously your
     obligations under this License and any other pertinent obligations,
     then as a consequence you may not convey it at all.  For example,
     if you agree to terms that obligate you to collect a royalty for
     further conveying from those to whom you convey the Program, the
     only way you could satisfy both those terms and this License would
     be to refrain entirely from conveying the Program.

  13. Remote Network Interaction; Use with the GNU General Public
     License.

     Notwithstanding any other provision of this License, if you modify
     the Program, your modified version must prominently offer all users
     interacting with it remotely through a computer network (if your
     version supports such interaction) an opportunity to receive the
     Corresponding Source of your version by providing access to the
     Corresponding Source from a network server at no charge, through
     some standard or customary means of facilitating copying of
     software.  This Corresponding Source shall include the
     Corresponding Source for any work covered by version 3 of the GNU
     General Public License that is incorporated pursuant to the
     following paragraph.

     Notwithstanding any other provision of this License, you have
     permission to link or combine any covered work with a work licensed
     under version 3 of the GNU General Public License into a single
     combined work, and to convey the resulting work.  The terms of this
     License will continue to apply to the part which is the covered
     work, but the work with which it is combined will remain governed
     by version 3 of the GNU General Public License.

  14. Revised Versions of this License.

     The Free Software Foundation may publish revised and/or new
     versions of the GNU Affero General Public License from time to
     time.  Such new versions will be similar in spirit to the present
     version, but may differ in detail to address new problems or
     concerns.

     Each version is given a distinguishing version number.  If the
     Program specifies that a certain numbered version of the GNU Affero
     General Public License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that numbered version or of any later version published by the Free
     Software Foundation.  If the Program does not specify a version
     number of the GNU Affero General Public License, you may choose any
     version ever published by the Free Software Foundation.

     If the Program specifies that a proxy can decide which future
     versions of the GNU Affero General Public License can be used, that
     proxy's public statement of acceptance of a version permanently
     authorizes you to choose that version for the Program.

     Later license versions may give you additional or different
     permissions.  However, no additional obligations are imposed on any
     author or copyright holder as a result of your choosing to follow a
     later version.

  15. Disclaimer of Warranty.

     THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
     APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE
     COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS"
     WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,
     INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE
     RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.
     SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL
     NECESSARY SERVICING, REPAIR OR CORRECTION.

  16. Limitation of Liability.

     IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES
     AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR
     DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
     CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE
     THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA
     BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
     PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
     PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF
     THE POSSIBILITY OF SUCH DAMAGES.

  17. Interpretation of Sections 15 and 16.

     If the disclaimer of warranty and limitation of liability provided
     above cannot be given local legal effect according to their terms,
     reviewing courts shall apply local law that most closely
     approximates an absolute waiver of all civil liability in
     connection with the Program, unless a warranty or assumption of
     liability accompanies a copy of the Program in return for a fee.

END OF TERMS AND CONDITIONS
===========================

How to Apply These Terms to Your New Programs
=============================================

If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these
terms.

   To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
state the exclusion of warranty; and each file should have at least the
"copyright" line and a pointer to where the full notice is found.

     ONE LINE TO GIVE THE PROGRAM'S NAME AND A BRIEF IDEA OF WHAT IT DOES.
     Copyright (C) YEAR NAME OF AUTHOR

     This program is free software: you can redistribute it and/or modify
     it under the terms of the GNU Affero General Public License as published by
     the Free Software Foundation, either version 3 of the License, or (at
     your option) any later version.

     This program is distributed in the hope that it will be useful, but
     WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     Affero General Public License for more details.

     You should have received a copy of the GNU Affero General Public License
     along with this program.  If not, see <http://www.gnu.org/licenses/>.

   Also add information on how to contact you by electronic and paper
mail.

   If your software can interact with users remotely through a computer
network, you should also make sure that it provides a way for users to
get its source.  For example, if your program is a web application, its
interface could display a "Source" link that leads users to an archive
of the code.  There are many ways you could offer source, and different
solutions will be better for different programs; see section 13 for the
specific requirements.

   You should also get your employer (if you work as a programmer) or
school, if any, to sign a "copyright disclaimer" for the program, if
necessary.  For more information on this, and how to apply and follow
the GNU AGPL, see <http://www.gnu.org/licenses/>.

GNU-FDL
*******

                     Version 1.3, 3 November 2008

     Copyright (C) 2000, 2001, 2002, 2007, 2008 Free Software Foundation, Inc.
     <http://fsf.org/>

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     functional and useful document "free" in the sense of freedom: to
     assure everyone the effective freedom to copy and redistribute it,
     with or without modifying it, either commercially or
     noncommercially.  Secondarily, this License preserves for the
     author and publisher a way to get credit for their work, while not
     being considered responsible for modifications made by others.

     This License is a kind of "copyleft", which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.  We
     recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work, in any medium,
     that contains a notice placed by the copyright holder saying it can
     be distributed under the terms of this License.  Such a notice
     grants a world-wide, royalty-free license, unlimited in duration,
     to use that work under the conditions stated herein.  The
     "Document", below, refers to any such manual or work.  Any member
     of the public is a licensee, and is addressed as "you".  You accept
     the license if you copy, modify or distribute the work in a way
     requiring permission under copyright law.

     A "Modified Version" of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A "Secondary Section" is a named appendix or a front-matter section
     of the Document that deals exclusively with the relationship of the
     publishers or authors of the Document to the Document's overall
     subject (or to related matters) and contains nothing that could
     fall directly within that overall subject.  (Thus, if the Document
     is in part a textbook of mathematics, a Secondary Section may not
     explain any mathematics.)  The relationship could be a matter of
     historical connection with the subject or with related matters, or
     of legal, commercial, philosophical, ethical or political position
     regarding them.

     The "Invariant Sections" are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in the
     notice that says that the Document is released under this License.
     If a section does not fit the above definition of Secondary then it
     is not allowed to be designated as Invariant.  The Document may
     contain zero Invariant Sections.  If the Document does not identify
     any Invariant Sections then there are none.

     The "Cover Texts" are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.  A
     Front-Cover Text may be at most 5 words, and a Back-Cover Text may
     be at most 25 words.

     A "Transparent" copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, that is suitable for revising the document
     straightforwardly with generic text editors or (for images composed
     of pixels) generic paint programs or (for drawings) some widely
     available drawing editor, and that is suitable for input to text
     formatters or for automatic translation to a variety of formats
     suitable for input to text formatters.  A copy made in an otherwise
     Transparent file format whose markup, or absence of markup, has
     been arranged to thwart or discourage subsequent modification by
     readers is not Transparent.  An image format is not Transparent if
     used for any substantial amount of text.  A copy that is not
     "Transparent" is called "Opaque".

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and standard-conforming
     simple HTML, PostScript or PDF designed for human modification.
     Examples of transparent image formats include PNG, XCF and JPG.
     Opaque formats include proprietary formats that can be read and
     edited only by proprietary word processors, SGML or XML for which
     the DTD and/or processing tools are not generally available, and
     the machine-generated HTML, PostScript or PDF produced by some word
     processors for output purposes only.

     The "Title Page" means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, "Title
     Page" means the text near the most prominent appearance of the
     work's title, preceding the beginning of the body of the text.

     The "publisher" means any person or entity that distributes copies
     of the Document to the public.

     A section "Entitled XYZ" means a named subunit of the Document
     whose title either is precisely XYZ or contains XYZ in parentheses
     following text that translates XYZ in another language.  (Here XYZ
     stands for a specific section name mentioned below, such as
     "Acknowledgements", "Dedications", "Endorsements", or "History".)
     To "Preserve the Title" of such a section when you modify the
     Document means that it remains a section "Entitled XYZ" according
     to this definition.

     The Document may include Warranty Disclaimers next to the notice
     which states that this License applies to the Document.  These
     Warranty Disclaimers are considered to be included by reference in
     this License, but only as regards disclaiming warranties: any other
     implication that these Warranty Disclaimers may have is void and
     has no effect on the meaning of this License.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow the
     conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies (or copies in media that commonly
     have printed covers) of the Document, numbering more than 100, and
     the Document's license notice requires Cover Texts, you must
     enclose the copies in covers that carry, clearly and legibly, all
     these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the title
     equally prominent and visible.  You may add other material on the
     covers in addition.  Copying with changes limited to the covers, as
     long as they preserve the title of the Document and satisfy these
     conditions, can be treated as verbatim copying in other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a machine-readable
     Transparent copy along with each Opaque copy, or state in or with
     each Opaque copy a computer-network location from which the general
     network-using public has access to download using public-standard
     network protocols a complete Transparent copy of the Document, free
     of added material.  If you use the latter option, you must take
     reasonably prudent steps, when you begin distribution of Opaque
     copies in quantity, to ensure that this Transparent copy will
     remain thus accessible at the stated location until at least one
     year after the last time you distribute an Opaque copy (directly or
     through your agents or retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of copies,
     to give them a chance to provide you with an updated version of the
     Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with the
     Modified Version filling the role of the Document, thus licensing
     distribution and modification of the Modified Version to whoever
     possesses a copy of it.  In addition, you must do these things in
     the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of previous
          versions (which should, if there were any, be listed in the
          History section of the Document).  You may use the same title
          as a previous version if the original publisher of that
          version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has fewer than five), unless they release you
          from this requirement.

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document's
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section Entitled "History", Preserve its Title,
          and add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on the
          Title Page.  If there is no section Entitled "History" in the
          Document, create one stating the title, year, authors, and
          publisher of the Document as given on its Title Page, then add
          an item describing the Modified Version as stated in the
          previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in the
          "History" section.  You may omit a network location for a work
          that was published at least four years before the Document
          itself, or if the original publisher of the version it refers
          to gives permission.

       K. For any section Entitled "Acknowledgements" or "Dedications",
          Preserve the Title of the section, and preserve in the section
          all the substance and tone of each of the contributor
          acknowledgements and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document, unaltered
          in their text and in their titles.  Section numbers or the
          equivalent are not considered part of the section titles.

       M. Delete any section Entitled "Endorsements".  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section to be Entitled
          "Endorsements" or to conflict in title with any Invariant
          Section.

       O. Preserve any Warranty Disclaimers.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option designate
     some or all of these sections as invariant.  To do this, add their
     titles to the list of Invariant Sections in the Modified Version's
     license notice.  These titles must be distinct from any other
     section titles.

     You may add a section Entitled "Endorsements", provided it contains
     nothing but endorsements of your Modified Version by various
     parties--for example, statements of peer review or that the text
     has been approved by an organization as the authoritative
     definition of a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end of
     the list of Cover Texts in the Modified Version.  Only one passage
     of Front-Cover Text and one of Back-Cover Text may be added by (or
     through arrangements made by) any one entity.  If the Document
     already includes a cover text for the same cover, previously added
     by you or by arrangement made by the same entity you are acting on
     behalf of, you may not add another; but you may replace the old
     one, on explicit permission from the previous publisher that added
     the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination all
     of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice, and that you preserve all
     their Warranty Disclaimers.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections Entitled
     "History" in the various original documents, forming one section
     Entitled "History"; likewise combine any sections Entitled
     "Acknowledgements", and any sections Entitled "Dedications".  You
     must delete all sections Entitled "Endorsements."

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the documents
     in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow this
     License in all other respects regarding verbatim copying of that
     document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of a
     storage or distribution medium, is called an "aggregate" if the
     copyright resulting from the compilation is not used to limit the
     legal rights of the compilation's users beyond what the individual
     works permit.  When the Document is included in an aggregate, this
     License does not apply to the other works in the aggregate which
     are not themselves derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one half
     of the entire aggregate, the Document's Cover Texts may be placed
     on covers that bracket the Document within the aggregate, or the
     electronic equivalent of covers if the Document is in electronic
     form.  Otherwise they must appear on printed covers that bracket
     the whole aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License, and all the license notices in the
     Document, and any Warranty Disclaimers, provided that you also
     include the original English version of this License and the
     original versions of those notices and disclaimers.  In case of a
     disagreement between the translation and the original version of
     this License or a notice or disclaimer, the original version will
     prevail.

     If a section in the Document is Entitled "Acknowledgements",
     "Dedications", or "History", the requirement (section 4) to
     Preserve its Title (section 1) will typically require changing the
     actual title.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense, or distribute it is void,
     and will automatically terminate your rights under this License.

     However, if you cease all violation of this License, then your
     license from a particular copyright holder is reinstated (a)
     provisionally, unless and until the copyright holder explicitly and
     finally terminates your license, and (b) permanently, if the
     copyright holder fails to notify you of the violation by some
     reasonable means prior to 60 days after the cessation.

     Moreover, your license from a particular copyright holder is
     reinstated permanently if the copyright holder notifies you of the
     violation by some reasonable means, this is the first time you have
     received notice of violation of this License (for any work) from
     that copyright holder, and you cure the violation prior to 30 days
     after your receipt of the notice.

     Termination of your rights under this section does not terminate
     the licenses of parties who have received copies or rights from you
     under this License.  If your rights have been terminated and not
     permanently reinstated, receipt of a copy of some or all of the
     same material does not give you any rights to use it.

  10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     <http://www.gnu.org/copyleft/>.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If the
     Document does not specify a version number of this License, you may
     choose any version ever published (not as a draft) by the Free
     Software Foundation.  If the Document specifies that a proxy can
     decide which future versions of this License can be used, that
     proxy's public statement of acceptance of a version permanently
     authorizes you to choose that version for the Document.

  11. RELICENSING

     "Massive Multiauthor Collaboration Site" (or "MMC Site") means any
     World Wide Web server that publishes copyrightable works and also
     provides prominent facilities for anybody to edit those works.  A
     public wiki that anybody can edit is an example of such a server.
     A "Massive Multiauthor Collaboration" (or "MMC") contained in the
     site means any set of copyrightable works thus published on the MMC
     site.

     "CC-BY-SA" means the Creative Commons Attribution-Share Alike 3.0
     license published by Creative Commons Corporation, a not-for-profit
     corporation with a principal place of business in San Francisco,
     California, as well as future copyleft versions of that license
     published by that same organization.

     "Incorporate" means to publish or republish a Document, in whole or
     in part, as part of another Document.

     An MMC is "eligible for relicensing" if it is licensed under this
     License, and if all works that were first published under this
     License somewhere other than this MMC, and subsequently
     incorporated in whole or in part into the MMC, (1) had no cover
     texts or invariant sections, and (2) were thus incorporated prior
     to November 1, 2008.

     The operator of an MMC Site may republish an MMC contained in the
     site under CC-BY-SA on the same site at any time before August 1,
     2009, provided the MMC is eligible for relicensing.

ADDENDUM: How to use this License for your documents
====================================================

To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.3
       or any later version published by the Free Software Foundation;
       with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
       Texts.  A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have Invariant Sections, Front-Cover Texts and Back-Cover
Texts, replace the "with...Texts."  line with this:

         with the Invariant Sections being LIST THEIR TITLES, with
         the Front-Cover Texts being LIST, and with the Back-Cover Texts
         being LIST.

   If you have Invariant Sections without Cover Texts, or some other
combination of the three, merge those two alternatives to suit the
situation.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of free
software license, such as the GNU General Public License, to permit
their use in free software.